<?php
if ( ! defined( 'ABSPATH' ) ) {
	exit; // Exit if accessed directly
}

add_filter( 'woocommerce_before_add_to_cart_button', 'wscsd_pick_date_field', 20 );
/** 
 * Adds custom field for Product
 * 
 * @return [type] [description]
 *
 */
function wscsd_pick_date_field() {
	global $product, $post;
	ob_start();

	$delay_type = get_post_meta( $post->ID, '_wscsd_delay_type', true );
	$dates = '';
	$start_date = '';
	
	if ( !empty( $delay_type ) ) {
		$start_label = get_post_meta( $post->ID, '_wscsd_start_label', true );
		$hide_date = get_post_meta( $post->ID, '_wscsd_hide_date', true );
		$max_dates = get_post_meta( $post->ID, '_wscsd_max_dates', true );
		$multiple_dates = 1;
		if ( 1 == $max_dates ) {
			$multiple_dates = 0;
		}
		$count_dates = 1;
		$nb_date_displayed = 0;
		$site_time_offset = (int) ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );

		if (!( $product->is_type( 'variable-subscription' ) )) {
			if ( 'fixed' == $delay_type ) {
				// Fixed dates
				$dates = apply_filters( 'wscsd_filter_future_dates', get_post_meta( $post->ID, '_wscsd_fixed_start_dates', true ), $post->ID );

				if ( !empty( $dates ) ) {
					
					if ( true == $hide_date ) {
						//if date is hidden
						foreach ( $dates as $date ) {
							if ( ( !empty( $date ) ) && ( $date >= get_cut_off_date( $post->ID ) ) ) {
								if ( empty( $start_date ) || ( $date < $start_date ) ) {
									$start_date = $date;
									echo '<input type="hidden" id="wscsd_start_date" name="wscsd_start_date" style="display:none;" value="' . esc_html__( $start_date ) . '">';
								}
							}
						}
					} else {
						//if date( s ) is shown
						
						if ( ( ( 1 == count( $dates ) ) || ( 0 == $multiple_dates ) ) && ( $dates[0] >= get_cut_off_date( $post->ID ) ) ) {
							// Only one date
							echo '<div class="wscsd_date_picker">';
							if ( !empty( $start_label ) ) {
								// Label
								echo '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd' ) . '</label>';
							}
							echo '<span id="wscsd_start_date_display">' . esc_html__( gmdate( get_option( 'date_format' ), strtotime( $dates[0] ) ) ) . '</span>';
							echo '<input type="hidden" id="wscsd_start_date" name="wscsd_start_date" value="' . esc_html__( $dates[0] ) . '" style="display:none;">';
							echo '</div>';

						} elseif ( ( 1 < count( $dates ) ) && ( 1 == $multiple_dates ) ) {
							// Multiple dates
							$future_dates = array();
							foreach ( $dates as $date ) {
								if ( ( !empty( $date ) ) && ( $date >= get_cut_off_date( $post->ID ) ) ) {
									if ( ( $count_dates <= $max_dates ) ||  ( 0 == $max_dates ) || ( '' == $max_dates ) ) {
										$future_dates[] = $date;
										$start_date = $date;
										$count_dates++;
									}	
								}
							}
							if ( 1 == count( $future_dates ) ) {
								echo '<div class="wscsd_date_picker">';
								if ( !empty( $start_label ) ) {
									// Label
									echo '<label for="wscsd_date_picker_display">' . esc_html__( $start_label ) . '</label>';
								}
								echo '<span id="wscsd_date_picker_display" name="wscsd_date_picker_one" value="' . esc_html( $start_date ) . '">' . esc_html__( date_i18n( wc_date_format(), strtotime( $future_date ) ) ) . '</span>';
								echo '</div>';
							} elseif ( 1 < count( $future_dates ) ) {
								echo '<div class="wscsd_date_picker">';
								if ( !empty( $start_label ) ) {
									// Label
									echo '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
								}
								echo '<span id="wscsd_date_picker_display" name="wscsd_date_picker_dropdown">';
								echo '<select id="wscsd_start_date" name="wscsd_start_date">';
								foreach ( $future_dates as $future_date ) {
									echo '<option value="' . esc_html__( $future_date ) . '">' . esc_html__( date_i18n( wc_date_format(), strtotime( $future_date ) ) ) . '</option>';   		    
								}
								echo '</select>';
								echo '</span>';
								echo '</div>';
							}
						}

					}
				}
			} elseif ( 'delay' == $delay_type ) {
				$delays = get_post_meta( $post->ID, '_wscsd_fixed_delays', true );
				if ( !empty( $delays ) ) {
					echo '<div class="wscsd_date_picker">';
					if ( !empty( $start_label ) ) {
						// Label
						echo '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
					}
					if ( 1 == count( $delays ) ) {
							// Only one delay
						echo '<span id="wscsd_start_date_display">' . esc_html__( date_i18n( wc_date_format(), strtotime( $delays[0] )  + $site_time_offset ) ) . '</span>';
						echo '<input id="wscsd_start_date" name="wscsd_start_date" value="' . esc_html__( gmdate( 'Y-m-d', strtotime( $delays[0] ) + $site_time_offset ) ) . '" style="display:none;">';
					} else {
						//multiple delays
						echo '<span id="wscsd_date_picker_display" name="wscsd_date_picker_dropdown">';
						echo '<select id="wscsd_start_date" name="wscsd_start_date">';
						foreach ( $delays as $delay ) {
							echo '<option value="' . esc_html__( gmdate( 'Y-m-d', strtotime( $delay ) + $site_time_offset ) ) . '">' . esc_html__( date_i18n( wc_date_format(), strtotime( $delay )  + $site_time_offset ) ) . '</option>';      
						}
								echo '</select>';
								echo '</span>';
					}
					echo '</div>';
					
				}
			} elseif ( 'calendar' == $delay_type ) {
				echo '<div class="wscsd_date_picker">';
				if ( !empty( $start_label ) ) {
					// Label
					echo '<label for="wscsd_start_date">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
				}
				$defaultDate = gmdate( 'Y-m-d', strtotime( 'now' ) + $site_time_offset );
				//$defaultDate = date_i18n( 'Y-m-d', strtotime( 'now' ));
				if ( get_cut_off_date( $post->ID ) > $defaultDate ) {
					$defaultDate = get_cut_off_date( $post->ID );
				}
				$cut_off_max = get_post_meta( $post->ID, '_wscsd_cut_off_max', true );
				$cut_off_max_date = '';
				if ( 'fixed_date' == $cut_off_max ) {
					$cut_off_max_date = get_post_meta( $post->ID, '_wscsd_cut_off_max_fixed_date', true );
				} else if ( 'period' == $cut_off_max ) {
					$cut_off_max_date = gmdate( 'Y-m-d', strtotime( get_post_meta( $post->ID, '_wscsd_cut_off_max_delay', true ) . ' ' . get_post_meta( $post->ID, '_wscsd_cut_off_max_delay_period', true ) ) );
				}
				echo '<input type="date" class="short wscsd_calendar_dates_field" style="" id="wscsd_start_date" name="wscsd_start_date" min="' . esc_html( get_cut_off_date( $post->ID ) ) . '" max="' . esc_html( $cut_off_max_date ) . '" value="' . esc_html( $defaultDate ) . '" placeholder="' . esc_html( $defaultDate ) . '">';
				echo '</div>';

			}
		}
		echo '<div class="clear"></div>';
	}
	$content = ob_get_contents();
	ob_end_flush();

	return $content;

}

function get_cut_off_date( $post_ID ) {
	//Cut off date
	$wscsd_cut_off = get_post_meta( $post_ID, '_wscsd_cut_off', true ) ? get_post_meta( $post_ID, '_wscsd_cut_off', true ) : 0;
	$wscsd_cut_off_period = get_post_meta( $post_ID, '_wscsd_cut_off_period', true ) ? get_post_meta( $post_ID, '_wscsd_cut_off_period', true ) : 'day';
	//$wscsd_cut_off_date = gmdate( 'Y-m-d' );
	$site_time_offset = (int) ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );
	$wscsd_cut_off_date = date_i18n( 'Y-m-d', strtotime( 'now' ) + $site_time_offset );
	if ( 0 != $wscsd_cut_off ) {
		//$wscsd_cut_off_date =  $wscsd_cut_off >= 0 ? date_i18n( 'Y-m-d', strtotime( '+' . $wscsd_cut_off . ' ' . $wscsd_cut_off_period )  + $site_time_offset ) : date_i18n( 'Y-m-d', strtotime( '-' . $wscsd_cut_off . ' ' . $wscsd_cut_off_period )  + $site_time_offset );
		$wscsd_cut_off_date = date_i18n( 'Y-m-d', strtotime( '+' . $wscsd_cut_off . ' ' . $wscsd_cut_off_period )  + $site_time_offset );
	}
	return $wscsd_cut_off_date;
}

function remove_dates_before_cut_off( $dates, $post_ID ) {
	$wscsd_cut_off_date = get_cut_off_date( $post_ID );
	$i = 0 ;
	foreach ( $dates as $date ) {
		if ( ( empty( $date ) ) || ( $date < $wscsd_cut_off_date ) ) {
			array_splice( $dates, $i, 1 );
		}
		$i++;
	}
	return $dates;
}
add_filter( 'wscsd_filter_future_dates', 'remove_dates_before_cut_off', 100, 2 );


//Display date picker on variation
add_filter('woocommerce_available_variation', 'wscsd_woocommerce_product_variation_start_date', 10, 3 );
function wscsd_woocommerce_product_variation_start_date( $variation_data, $product, $variation ) {
	$delay_type = $variation_data['delay_type'];
	$dates = '';
	$start_date = '';
	$start_date_display = '';
	
	if ( !empty( $delay_type ) ) {
		if ( 'product_default' == $delay_type ) {
			$product_id =  wp_get_post_parent_id( $variation->get_id() );
		} else {
			$product_id =  $variation->get_id();
		}
		$delay_type = get_post_meta( $product_id, '_wscsd_delay_type', true );
		$start_label = get_post_meta( $product_id, '_wscsd_start_label', true );
		$hide_date = get_post_meta( $product_id, '_wscsd_hide_date', true );
		$max_dates = get_post_meta( $product_id, '_wscsd_max_dates', true );
		//$start_label = $variation_data['start_label'];
		//$hide_date = $variation_data['hide_date'];
		//$max_dates = $variation_data['max_dates'];
		$multiple_dates = 1;
		if ( 1 == $max_dates ) {
			$multiple_dates = 0;
		}
		$count_dates = 1;
		$nb_date_displayed = 0;

		if ( 'fixed' == $delay_type ) {
			// Fixed dates
			$dates = apply_filters( 'wscsd_filter_future_dates', get_post_meta( $product_id, '_wscsd_fixed_start_dates', true), $product_id );

			if ( !empty( $dates ) ) {
				
				if ( true == $hide_date ) {
					//if date is hidden
					foreach ( $dates as $date ) {
						if ( ( !empty( $date ) ) && ( $date >= get_cut_off_date( $product_id ) ) ) {
							if ( empty( $start_date ) || ( $date < $start_date ) ) {
								$start_date = $date;
								$start_date_display .= '<input type="hidden" id="wscsd_start_date" name="wscsd_start_date" style="display:none;" value="' . esc_html__( $start_date ) . '">';
							}
						}
					}
				} else {
					//if date( s ) is shown
					
					if ( ( ( 1 == count( $dates ) ) || ( 0 == $multiple_dates ) ) && ( $dates[0] >= get_cut_off_date( $product_id ) ) ) {
						// Only one date
						$start_date_display .= '<div class="wscsd_date_picker">';
						if ( !empty( $start_label ) ) {
							// Label
							$start_date_display .= '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd' ) . '</label>';
						}
						$start_date_display .= '<span id="wscsd_start_date_display">' . esc_html__( gmdate( get_option( 'date_format' ), strtotime( $dates[0] ) ) ) . '</span>';
						$start_date_display .= '<input type="hidden" id="wscsd_start_date" name="wscsd_start_date" value="' . esc_html__( $dates[0] ) . '" style="display:none;">';
						$start_date_display .= '</div>';

					} elseif ( ( 1 < count( $dates ) ) && ( 1 == $multiple_dates ) ) {
						// Multiple dates
						$future_dates = array();
						foreach ( $dates as $date ) {
							if ( ( !empty( $date ) ) && ( $date >= get_cut_off_date( $product_id ) ) ) {
								if ( ( $count_dates <= $max_dates ) ||  ( 0 == $max_dates ) || ( '' == $max_dates ) ) {
									$future_dates[] = $date;
									$start_date = $date;
									$count_dates++;
								}	
							}
						}
						if ( 1 == count( $future_dates ) ) {
							$start_date_display .= '<div class="wscsd_date_picker">';
							if ( !empty( $start_label ) ) {
								// Label
								$start_date_display .= '<label for="wscsd_date_picker_display">' . esc_html__( $start_label ) . '</label>';
							}
							$start_date_display .= '<span id="wscsd_date_picker_display" name="wscsd_date_picker_one" value="' . esc_html( $start_date ) . '">' . esc_html__( date_i18n( wc_date_format(), strtotime( $future_date ) ) ) . '</span>';
							$start_date_display .= '</div>';
						} elseif ( 1 < count( $future_dates ) ) {
							$start_date_display .= '<div class="wscsd_date_picker">';
							if ( !empty( $start_label ) ) {
								// Label
								$start_date_display .= '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
							}
							$start_date_display .= '<span id="wscsd_date_picker_display" name="wscsd_date_picker_dropdown">';
							$start_date_display .= '<select id="wscsd_start_date" name="wscsd_start_date">';
							foreach ( $future_dates as $future_date ) {
								$start_date_display .= '<option value="' . esc_html__( $future_date ) . '">' . esc_html__( date_i18n( wc_date_format(), strtotime( $future_date ) ) ) . '</option>';   		    
							}
							$start_date_display .= '</select>';
							$start_date_display .= '</span>';
							$start_date_display .= '</div>';
						}
					}

				}
			}
		} elseif ( 'delay' == $delay_type ) {
			$delays = get_post_meta( $product_id, '_wscsd_fixed_delays', true );
			if ( !empty( $delays ) ) {
				$start_date_display .= '<div class="wscsd_date_picker">';
				if ( !empty( $start_label ) ) {
					// Label
					$start_date_display .= '<label for="wscsd_date_picker_display">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
				}
				if ( 1 == count( $delays ) ) {
						// Only one delay
					$start_date_display .= '<span id="wscsd_start_date_display">' . esc_html__( gmdate( 'Y-m-d', strtotime( $delays[0] ) ) ) . '</span>';
					$start_date_display .= '<input id="wscsd_start_date" name="wscsd_start_date" value="' . esc_html__( gmdate( get_option( 'date_format' ), strtotime( $delays[0] ) ) ) . '" style="display:none;">';
				} else {
					//multiple delays
					$start_date_display .= '<span id="wscsd_date_picker_display" name="wscsd_date_picker_dropdown">';
					$start_date_display .= '<select id="wscsd_start_date" name="wscsd_start_date">';
					foreach ( $delays as $delay ) {
						$start_date_display .= '<option value="' . esc_html__( gmdate( 'Y-m-d', strtotime( $delay ) ) ) . '">' . esc_html__( gmdate(get_option( 'date_format' ), strtotime( $delay ) ) ) . '</option>';      
					}
							$start_date_display .= '</select>';
							$start_date_display .= '</span>';
				}
				$start_date_display .= '</div>';
				
			}
		} elseif ( 'calendar' == $delay_type ) {
			$start_date_display .= '<div class="wscsd_date_picker">';
			if ( !empty( $start_label ) ) {
				// Label
				$start_date_display .= '<label for="wscsd_start_date">' . esc_html__( $start_label, 'wscsd'  ) . '</label>';
			}
			//$defaultDate = gmdate( 'Y-m-d', strtotime( 'now' ) );
			$site_time_offset = (int) ( get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );
			$defaultDate = gmdate( 'Y-m-d', strtotime( 'now' ) + $site_time_offset );
			if ( get_cut_off_date( $product_id ) > $defaultDate ) {
				$defaultDate = get_cut_off_date( $product_id );
			}
			$cut_off_max = get_post_meta( $product_id, '_wscsd_cut_off_max', true );
			$cut_off_max_date = '';
			if ( 'fixed_date' == $cut_off_max ) {
				$cut_off_max_date = get_post_meta( $product_id, '_wscsd_cut_off_max_fixed_date', true );
			} else if ( 'period' == $cut_off_max ) {
				$cut_off_max_date = gmdate( 'Y-m-d', strtotime( get_post_meta( $product_id, '_wscsd_cut_off_max_delay', true ) . ' ' . get_post_meta( $product_id, '_wscsd_cut_off_max_delay_period', true ) ) );
			}
			$start_date_display .= '<input type="date" class="short wscsd_calendar_dates_field" style="" id="wscsd_start_date" name="wscsd_start_date" min="' . esc_html( get_cut_off_date( $product_id ) ) . '" max="' . esc_html( $cut_off_max_date ) . '" value="' . esc_html( $defaultDate ) . '" placeholder="' . esc_html( $defaultDate ) . '">';
			$start_date_display .= '</div>';


		}
		$start_date_display .= '<div class="clear"></div>';
	}
	$variation_data['start_date_display'] = $start_date_display;
	return $variation_data;
}
